Data defined label does not works anymore in combinaison with rule based labeling
Status: Closed

Priority: High

Assignee: Nyall Dawson

Category: Labelling

Affected QGIS version:3.2.3 Regression?: Yes
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27801
Description

Please find in attachement a simple project that illustrate the issue : trying moving a label does not works.

The issue appears since 3.2.2 or 3.2.3 (as | tested it works correctly on 3.2.0 and fails on 3.2.3).

After more investigation, | could notice that a project with this kind of setup saved with 3.2.0 also works correctly on 3.2.3 but will fails
again if the rules are editing. Comparing qgs files between a working and non working reveals that non working file missing rule uuid :

working qgs file:
<labeling type="rule-based">
<rules key="{106f3856-6dcc-4ea3-8be9-d41a6fa39b68}">

non working qgs file:
<labeling type="rule-based">
<rules key="">

Adding an uuid make the labels movable again.
Investigate the commits, it seems b6901e2 is the cause of the regression : uuid creation was removed from qgsrulebasedlabeling.cpp

(line 68)
https://github.com/qgis/QGIS/commit/b6901e286c8389bddccb72i696657bde64755897

Associated revisions

Revision 0e2ceb90 - 2018-10-01 08:07 AM - Nyall Dawson

Fix rule based labeling does not permit moving labels using interactive tool

Fixes #19979

History

#1 - 2018-10-01 06:14 AM - Nyall Dawson
- Assignee set to Nyall Dawson
- Status changed from Open to In Progress

#2 - 2018-10-01 08:07 AM - Nyall Dawson

- % Done changed from 0 to 100

- Status changed from In Progress to Closed
https://github.com/qgis/QGIS/commit/b6901e286c8389bddccb72f69e657bde64755897

Applied in changeset commit:qgis|0e2ceb90fe3c4816a71fa681d28a351fdff9c7ab.

#3 - 2019-04-30 09:30 PM - Decio Yokota

Moving labels doesn't seem to work again in version 3.6.2. This is probably true in earlier versions as seen in:

https://gis.stackexchange.com/questions/290780/move-label-not-working/321272#321272

Manually clicking in data defined X and Y coordinates and storing them on project makes it work.
